# All files / src/custom-nodes/self-defending-nodes/factory SelfDefendingCustomNodeGroup.ts

68.18% Statements 15/22
50% Branches 1/2
100% Functions 1/1
66.67% Lines 14/21

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    671x
    1x

    1x
    1x

    1x
    1x
    1x

    1x
    1x

    1603x

    1603x

    1603x

    1603x
    1603x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from '../../../container/ServiceIdentifiers';

    import { TCustomNodeFactory } from '../../../types/container/TCustomNodeFactory';
    import { TObfuscationEvent } from '../../../types/event-emitters/TObfuscationEvent';

    import { ICustomNode } from '../../../interfaces/custom-nodes/ICustomNode';
    import { IOptions } from '../../../interfaces/options/IOptions';
    import { IStackTraceData } from '../../../interfaces/stack-trace-analyzer/IStackTraceData';

    import { CustomNodes } from '../../../enums/container/CustomNodes';
    import { ObfuscationEvents } from '../../../enums/ObfuscationEvents';

    import { AbstractCustomNodesFactory } from '../../AbstractCustomNodesFactory';
    import { NodeAppender } from '../../../node/NodeAppender';
    import { Utils } from '../../../Utils';

    @injectable()
    export class SelfDefendingCustomNodesFactory extends AbstractCustomNodesFactory {
        /**
         * @type {TObfuscationEvent}
         */
        protected appendEvent: TObfuscationEvent = ObfuscationEvents.AfterObfuscation;

        /**
         * @type {TCustomNodeFactory}
         */
        private readonly customNodeFactory: TCustomNodeFactory;

        /**
         * @param customNodeFactory
         * @param options
         */
        constructor (
            @inject(ServiceIdentifiers['Factory<ICustomNode>']) customNodeFactory: TCustomNodeFactory,
            @inject(ServiceIdentifiers.IOptions) options: IOptions
        ) {
            super(options);

            this.customNodeFactory = customNodeFactory;
        }

        /**
         * @param stackTraceData
         * @returns {Map<string, ICustomNode>}
         */
        public initializeCustomNodes (stackTraceData: IStackTraceData[]): Map <string, ICustomNode> | undefined {
            Eif (!this.options.selfDefending) {
                return;
            }

            const callsControllerFunctionName: string = Utils.getRandomVariableName();
            const randomStackTraceIndex: number = NodeAppender.getRandomStackTraceIndex(stackTraceData.length);

            const selfDefendingUnicodeNode: ICustomNode = this.customNodeFactory(CustomNodes.SelfDefendingUnicodeNode);
            const nodeCallsControllerFunctionNode: ICustomNode = this.customNodeFactory(CustomNodes.NodeCallsControllerFunctionNode);

            selfDefendingUnicodeNode.initialize(callsControllerFunctionName, randomStackTraceIndex);
            nodeCallsControllerFunctionNode.initialize(callsControllerFunctionName, randomStackTraceIndex);

            return this.syncCustomNodesWithNodesFactory(new Map <string, ICustomNode> ([
                ['selfDefendingUnicodeNode', selfDefendingUnicodeNode],
                ['SelfDefendingNodeCallsControllerFunctionNode', nodeCallsControllerFunctionNode]
            ]));
        }
    }